"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.playgroundDefaultSettings = exports.schema = exports.DEPRECATED_HANDLER_PATH = exports.APOLLO_SERVER_MIDWAY_PATH = exports.ORIGIN_GRAPHQL_HANDLER_PATH = void 0;
const apollo_server_core_1 = require("apollo-server-core");
const schema_1 = require("@graphql-tools/schema");
exports.ORIGIN_GRAPHQL_HANDLER_PATH = '/graphql';
exports.APOLLO_SERVER_MIDWAY_PATH = '/apollo';
exports.DEPRECATED_HANDLER_PATH = '/deprecated';
const typeDefs = apollo_server_core_1.gql `
  type Query {
    users: [User!]!
    user(username: String): User
  }
  type User {
    name: String
    username: String
  }
`;
const users = [
    { name: 'Leeroy Jenkins', username: 'leeroy' },
    { name: 'Foo Bar', username: 'foobar' },
];
const resolvers = {
    Query: {
        users() {
            return users;
        },
        user(parent, { username }) {
            return users.find(user => user.username === username);
        },
    },
};
exports.schema = schema_1.makeExecutableSchema({ typeDefs, resolvers });
exports.playgroundDefaultSettings = {
    'editor.cursorShape': 'line',
    'editor.theme': 'dark',
    'editor.reuseHeaders': true,
    'tracing.hideTracingResponse': false,
    'queryPlan.hideQueryPlanResponse': false,
    'editor.fontSize': 14,
    'editor.fontFamily': 'Fira Code',
    'schema.polling.enable': true,
    'schema.polling.interval': 2000,
};
