import { GraphQLSchema } from 'graphql';
import { Context as FaaSContext } from '@midwayjs/faas';
import { PluginConfig, RenderPlaygroundQueryOptions } from './typing';
import { IMidwayContainer } from '@midwayjs/core';
export interface GraphQLContext extends FaaSContext {
    __key__: never;
}
export declare class GraphQLService {
    _schema?: GraphQLSchema;
    config: PluginConfig;
    constructor(container: IMidwayContainer, internalConfig: PluginConfig);
    private _init;
    private buildGraphQLSchema;
    get schema(): GraphQLSchema;
    handler(ctx: FaaSContext, config: PluginConfig): Promise<import("graphql").ExecutionResult<{
        [key: string]: any;
    }, {
        [key: string]: any;
    }>>;
    playground(ctx: FaaSContext, renderOptions: RenderPlaygroundQueryOptions): Promise<void>;
}
