"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GraphQLService = void 0;
const graphql_1 = require("graphql");
const decorator_1 = require("@midwayjs/decorator");
const path = __importStar(require("path"));
const type_graphql_1 = require("type-graphql");
const playground_faas_1 = require("./playground-faas");
const error_interceptor_1 = require("./error-interceptor");
let GraphQLService = class GraphQLService {
    constructor(container, internalConfig) {
        // FIXME:
        this.config = internalConfig;
        this._init();
    }
    _init() {
        const schema = this.buildGraphQLSchema();
        this._schema = schema;
    }
    // TODO: built-in options
    // useErrorInterceptor
    // resolvers
    // useContainer
    // useDirectives
    // useScalars
    // dateScalarMode
    // resolverTimeExtension
    // complexity
    buildGraphQLSchema() {
        return type_graphql_1.buildSchemaSync({
            resolvers: [path.resolve(__dirname, 'resolver/*')],
            dateScalarMode: 'timestamp',
            globalMiddlewares: [error_interceptor_1.ErrorInterceptor],
            container: () => {
                return {
                    get: (target, data) => {
                        // or resolve
                        return data.context.requestContext.getAsync(target);
                    },
                };
            },
        });
    }
    get schema() {
        return this._schema;
    }
    async handler(ctx, config) {
        var _a, _b;
        // 如果resolver也要提供，那么schema就需要重新构建了，不太行
        let body = ctx.req.body;
        if (body) {
            body = JSON.parse(body);
        }
        const { query, variables } = body;
        if (!this.schema || !Object.keys(this.schema).length) {
            throw new Error('[ Midway-FaaS-GraphQL ] Invalid Built GraphQLSchema');
        }
        return await graphql_1.graphql({
            schema: this.schema,
            source: query,
            variableValues: variables,
            contextValue: {
                // ...(this.config.context ?? {}),
                ...((_a = config.context) !== null && _a !== void 0 ? _a : {}),
                ...ctx,
            },
            // rootValue: this.config.rootValue ?? {},
            rootValue: (_b = config.rootValue) !== null && _b !== void 0 ? _b : {},
        });
    }
    async playground(ctx, renderOptions) {
        return playground_faas_1.midwayFaaSPlayground({ editorOptions: renderOptions })(ctx);
    }
};
GraphQLService = __decorate([
    decorator_1.Provide('GraphQLService'),
    __metadata("design:paramtypes", [Object, Object])
], GraphQLService);
exports.GraphQLService = GraphQLService;
