"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.midwayFaaSPlayground = void 0;
const graphql_playground_html_1 = require("graphql-playground-html");
function internalOptionsToSettings(options) {
    const settings = {};
    const mappings = {
        cursorShape: 'editor.cursorShape',
        theme: 'editor.theme',
        reuseHeaders: 'editor.reuseHeaders',
        globalHeaders: 'request.globalHeaders',
        hideTracingResponse: 'tracing.hideTracingResponse',
        tracingSupported: 'tracing.tracingSupported',
        fontSize: 'editor.fontSize',
        fontFamily: 'editor.fontFamily',
        enablePolling: 'schema.polling.enable',
        credentials: 'request.credentials',
    };
    for (const [k, v] of Object.entries(options !== null && options !== void 0 ? options : {})) {
        settings[mappings[k]] = v;
    }
    return settings;
}
function midwayFaaSPlayground(options) {
    return async (ctx) => {
        const transformedOptions = internalOptionsToSettings(options === null || options === void 0 ? void 0 : options.editorOptions);
        const internalplaygroundSettings = ctx.requestContext
            .getConfigService()
            .getConfiguration('graphqlPlaygroundSettings');
        const body = graphql_playground_html_1.renderPlaygroundPage({
            ...options,
            ...{
                workspaceName: 'playground',
                settings: {
                    ...internalplaygroundSettings,
                    ...transformedOptions,
                },
            },
        });
        ctx.type = 'text/html';
        ctx.body = body;
    };
}
exports.midwayFaaSPlayground = midwayFaaSPlayground;
